package at.aau.mmis;

import net.semanticmetadata.lire.utils.FileUtils;
import net.semanticmetadata.lire.utils.MetricsUtils;

import javax.imageio.ImageIO;
import java.awt.image.BufferedImage;
import java.awt.image.WritableRaster;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;

/**
 * Created by mlux on 14.05.14.
 */
public class ImageRetrieval {
    public static void main(String[] args) throws IOException {

        // (1) index all the files
        ArrayList<String> testdata = FileUtils.getAllImages(new File("C:\\Java\\Projects\\LireSVN\\testdata\\ferrari"), true); // that's the image files
        ArrayList<double[]> index = new ArrayList<double[]>(testdata.size()); // that's for the histograms

        for (Iterator<String> iterator = testdata.iterator(); iterator.hasNext(); ) {
            String imageFile = iterator.next();
            index.add(extract(imageFile));
        }

        // (2) search for a file based on your feature
        double[] query = extract(testdata.get(0));
        // go through the index and find the
        for (int i = 0, indexSize = index.size(); i < indexSize; i++) {
            double[] next = index.get(i);
            double distance = MetricsUtils.distL1(next, query);
            // TODO: create a ranked list ....
            System.out.println(testdata.get(i) + ", distance = " + distance);
        }

    }

    private static double[] extract(String imageFile) throws IOException {
        BufferedImage img = ImageIO.read(new File(imageFile));
        // init result
        double[] result = new double[16]; // change dimensions :)
        Arrays.fill(result, 0d);
        // create histogram from image ...
        WritableRaster raster = img.getRaster();
        int[] pixel = new int[3];
        for (int x = 0; x < raster.getWidth(); x++) {
            for (int y = 0; y < raster.getHeight(); y++) {
                raster.getPixel(x,y,pixel);
                // TODO: do something with the pixels ...
                result[(int) ((pixel[0] + pixel[1] + pixel[2])/(16d*3d))]++;
            }
        }
        // max norm:
        double max = 0;
        for (int i = 0; i < result.length; i++) {
            max = Math.max(result[i], max);
        }
        for (int i = 0; i < result.length; i++) {
            result[i] = result[i] / max;
        }
        return result;

    }


}
